// Generated by CoffeeScript 1.6.3
(function() {
  var Base, Notifier, util,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  Base = require('./Base');

  util = require('./util');

  /*
  The Notifier is the main class used when creating reactive functions
  */


  module.exports = Notifier = (function(_super) {
    __extends(Notifier, _super);

    Notifier.prototype.states = {
      ready: null,
      cancelled: 'handle_cancel',
      changed: 'handle_change'
    };

    function Notifier(monitor) {
      var f,
        _this = this;
      this.monitor = monitor;
      this.user$cancel = __bind(this.user$cancel, this);
      this.user$change = __bind(this.user$change, this);
      this.public_api = f = function() {
        return _this.user$change();
      };
      util.copy_event_emitter_methods(this, f);
      f.state = function() {
        return _this.state;
      };
      f.cancel = this.user$cancel;
      f.change = this.user$change;
    }

    Notifier.prototype.handle_cancel = function() {
      this.emit('cancel');
      return this.emit('destroy');
    };

    Notifier.prototype.handle_change = function() {
      this.emit('change');
      return this.emit('destroy');
    };

    Notifier.prototype.user$change = function() {
      var _this = this;
      return this.transition('changed', function() {
        return _this.monitor.notifier$change();
      });
    };

    Notifier.prototype.user$cancel = function() {
      var _this = this;
      return this.transition('cancelled', function() {
        return _this.monitor.notifier$cancel_notifier();
      });
    };

    Notifier.prototype.monitor$cancel = function() {
      return this.transition('cancelled');
    };

    return Notifier;

  })(Base);

}).call(this);
